{{
Servo1 : Paper feed
Servo2 : Move pen left/right
Servo3 : Move pen towards/from the paper

}}

con
  penmax = 300
  penmin = -200
  lrtime = 10 'ms

  penres = 10
  
  pendtime = 100
  penutime = 90
  penspeed = 50
  
  nrtime = 70
  nrspeed = 200
var
  long mise
  long servo[3]

obj
  s : "Servos.spin"

pub Start(f,l)|i
  mise := clkfreq / 1000
  servo[0] := 0
  servo[1] := 0
  servo[2] := 0


  s.start(f,l,@servo[0])

  'penup
  'wait (200)
  'startfeed
  'wait(3000)
  'stopfeed
'  return 
  'repeat i from 1 to 10
  '  setpenpos(penmax,10)
  '  'wait(lrtime)

  '  dot
    
  '  setpenpos(penmin,10)
    'wait(lrtime)
    
  '  nextrow
  '  dot

  'pendown
pub stop
  s.stop
pub Dot  
  pendown
  wait(100)
  penup
  wait(100)

pub StartFeed
  servo[0] := nrspeed / 5

pub StopFeed
  servo[0] :=  0

pub PenUp
  servo[2] := -penspeed
  wait(penutime)
  servo[2] := 0

pub PenDown
  servo[2] := penspeed
  wait(pendtime)
  servo[2] := 0

pub Print (pic,black,white,sta)|r,c,h,w,t,lp
  'startfeed
  'wait(500)
  'stopfeed
  w := byte[pic] * 8
  h := byte[pic + 1]
  lp := 100
  repeat c from 0 to w - 1
    byte[sta] := r
    nextrow
    setpenpos(penmin,lp+1)
    lp := 0
    repeat r from 0 to h - 1
      byte[sta + 1] := c
      'if getpix(pic,w - c - 1,r) == white
      if getpix(pic,c,r) == white
        setpenpos(penmin + (r * penres),(r - lp) + 1)
        lp := r
        dot
      else
  'startfeed
  'wait(1000)
  'stopfeed
  byte[sta] := $FF
  byte[sta + 1] := $FF
  
      
      
pri nextrow
  servo[0] := nrspeed
  wait(nrtime)                                                                                                    
  servo[0] := 0

pri SetPenPos(pos,et)|l
  l := servo[1]
  servo[1] := pos
  wait (lrtime * et) '* (||(||pos - ||l)))
          

pub wait(ms)
  waitcnt(mise * ms + cnt)

pri GetPix(sa,x,y):c|tmp,addr,w,xo
  w := byte[sa] * 2
  'if x => byte[sa] * 8
  '  return
  'if y => byte[sa + 1]
  '  return
  tmp := (x / 8) 
  addr := sa + tmp * 2
  addr += 4
  addr += y * w
  xo := 7 - (x - tmp * 8)
  xo *= 2
  tmp := (|< xo) + (|< (xo + 1))
  c := word[addr] & (tmp)
  c := c >> xo